#include <QProcess>
#include <QLineEdit>
#include <QTimer>
#include "searchwindow.h"
#include "ui_searchwindow.h"

searchWindow::searchWindow(QWidget *parent, QString searchword, QLineEdit *urlbox) :
    QDialog(parent),
    m_ui(new Ui::searchWindow)
{

    this->urlbox=urlbox;
    m_ui->setupUi(this);
    this->searchword=searchword;

    timer1 = new QTimer(this);
    connect(timer1, SIGNAL(timeout()), this, SLOT(pollProcess()));
}

searchWindow::~searchWindow()
{
    delete m_ui;
    delete timer1;
}

void searchWindow::changeEvent(QEvent *e)
{
    QDialog::changeEvent(e);
    switch (e->type()) {
    case QEvent::LanguageChange:
        m_ui->retranslateUi(this);
        break;
    default:
        break;
    }
}

void searchWindow::doSearch()
{

    m_ui->list->addItem ("Haku kynniss..");
    //Execute and wait for completion, shouldnt take too long
    process.start( "wget --user-agent=\"Mozilla/5.0 (Windows; U; Windows NT 6.1; en-US) AppleWebKit/530.5 (KHTML, like Gecko) Chrome/2.0.172.39 Safari/530.5\" --quiet -O - \"http://areena.yle.fi/haku//uusimmat/hakusana/"+searchword+"/media/video\"");
    ///For testing
    //process.start("wget --quiet -O - http://localhost/temp.txt");

    timer1->start(500);
}


void searchWindow::pollProcess()
{

    if(process.state()==0 )
    {
        //process.waitForFinished();

        //Remove item
        m_ui->list->takeItem(0);

        //Read data from the process
        QString data=QString( process.readAllStandardOutput());
        QString line;


        int index=data.indexOf("href=\"/video/");
        int lastnumber=0;
        //Parse video files
        while(index!=-1)
        {
            data.remove(0, index+13);
            index=data.indexOf("href=\"/video/");
            index=data.indexOf("href=\"/video/",index+13);
            index=data.indexOf("href=\"/video/",index+13);
            if(index!=-1)
            {
                QString seriesname=data.mid(data.indexOf(">",index)+1, data.indexOf("<",index)-(data.indexOf(">",index)+1));

                line=data.mid(index+13,data.indexOf(">",index+13)-(index+13)-1);
                lastnumber=line.toInt();
                int p_index=data.indexOf("<p>",index+13);
                QString linedata=data.mid(p_index+3,data.indexOf("p>",p_index+3)-(p_index+3)-2);
                linedata.replace("&ouml;", "");
                linedata.replace("&auml;", "");
                linedata.replace("&Auml;", "");
                linedata.replace("&Ouml;", "");

                seriesname.replace("&ouml;", "");
                seriesname.replace("&auml;", "");
                seriesname.replace("&Auml;", "");
                seriesname.replace("&Ouml;", "");
                m_ui->list->addItem("<"+line+"> "+seriesname+": "+linedata);

                data.remove(0, data.indexOf("p>",p_index+3));
                index=data.indexOf("href=\"/video/");
            }

        }
        timer1->stop();
    }
    else
        timer1->start(500);
}

QString urlFromRow(QString row)
{
    int index=row.indexOf(">");
    return "http://areena.yle.fi/video/"+row.mid(1,index-1);
}

void searchWindow::accept()
{
    QList<QListWidgetItem *> items = m_ui->list->selectedItems();

    QString data;
    for(int i=0;i<items.count();i++)
    {
        data+=((i==0)?"":";")+urlFromRow(items.at(i)->text());
    }
    urlbox->setText(urlbox->text()+data);
    this->close();
}
